<?php
	$protocols	= '[a-zA-Z0-9]+:'; //To check for all unknown protocals (a protocol must contain at least one alpahnumeric fillowed by :
	$base 		= '/docmanlist255/';
	$regex		= '#style\s*=\s*[\'\"](.*):\s*url\s*\([\'\"]?(?!/|'.$protocols.'|\#)([^\)\'\"]+)[\'\"]?\)#m';
	$testFile1 	= dirname(__FILE__) . '/docmanlist_get_subfolders_99_0_output.txt';
	$testFile2	= dirname(__FILE__) . '/docmanlist_get_subfolders_99_individual_output.txt';
	$testFile3	= dirname(__FILE__) . '/docmanlist_get_subfolders_99_0_output_without_inline_styles.txt';

	echo 'Test File 1: ' . $testFile1 . '<br />';
	echo 'Test File 2: ' . $testFile2 . '<br />';
	echo 'Test File 3: ' . $testFile3 . '<br />';
	echo "<br />";

	$buffer 	= file_get_contents($testFile1);
	$time_start = microtime(true);
	$newBuffer	= preg_replace($regex, 'style="$1: url(\''. $base .'$2$3\')', $buffer);
	$time_end = microtime(true);
	$time = round($time_end - $time_start, 3);

	if (empty($newBuffer))
	{
		echo "Buffer is now null (processed preg_replace() in $time seconds)<br />";
	}
	else
	{
		echo "Buffer is intact (processed preg_replace() in $time seconds)<br />";
	}

	$buffer 	= file_get_contents($testFile2);
	$time_start = microtime(true);
	$newBuffer	= preg_replace($regex, 'style="$1: url(\''. $base .'$2$3\')', $buffer);
	$time_end = microtime(true);
	$time = round($time_end - $time_start, 3);

	if (empty($newBuffer))
	{
		echo "Buffer is now null (processed preg_replace() in $time seconds)<br />";
	}
	else
	{
		echo "Buffer is intact (processed preg_replace() in $time seconds)<br />";
	}

	$buffer 	= file_get_contents($testFile3);
	$time_start = microtime(true);
	$newBuffer	= preg_replace($regex, 'style="$1: url(\''. $base .'$2$3\')', $buffer);
	$time_end = microtime(true);
	$time = round($time_end - $time_start, 3);

	if (empty($newBuffer))
	{
		echo "Buffer is now null (processed preg_replace() in $time seconds)<br />";
	}
	else
	{
		echo "Buffer is intact (processed preg_replace() in $time seconds)<br />";
	}


	// Find the longest line length from each file:
	echo "<br />";
	echo "<br />";
	$file = fopen($testFile1, 'rb');

	$line = '';
	$longest = '';
	$longest_on = 0;
	$num_lines = 0;

	for ($num_lines = 1 ; ($line = fgets($file)) != false ; $num_lines++)
	{
	    if (strlen($line) > strlen($longest))
	    {
	        $longest = $line;
	        $longest_on = $num_lines;
	    }
	}

	if ($longest_on)
	{
	    echo 'Test File 1 had total of ', $num_lines, ' lines.', "<br />";
	    echo 'Longest line found on line ', $longest_on, ' with ', strlen($longest), ' characters.', "<br />";
	}

	// Test 2:
	echo "<br />";
	echo "<br />";
	$file = fopen($testFile2, 'rb');

	$line = '';
	$longest = '';
	$longest_on = 0;
	$num_lines = 0;

	for ($num_lines = 1 ; ($line = fgets($file)) != false ; $num_lines++)
	{
	    if (strlen($line) > strlen($longest))
	    {
	        $longest = $line;
	        $longest_on = $num_lines;
	    }
	}

	if ($longest_on)
	{
	    echo 'Test File 2 had total of ', $num_lines, ' lines.', "<br />";
	    echo 'Longest line found on line ', $longest_on, ' with ', strlen($longest), ' characters.', "<br />";
	}

	// Test File 3:
	echo "<br />";
	echo "<br />";
	$file = fopen($testFile3, 'rb');

	$line = '';
	$longest = '';
	$longest_on = 0;
	$num_lines = 0;

	for ($num_lines = 1 ; ($line = fgets($file)) != false ; $num_lines++)
	{
	    if (strlen($line) > strlen($longest))
	    {
	        $longest = $line;
	        $longest_on = $num_lines;
	    }
	}

	if ($longest_on)
	{
	    echo 'Test File 3 had total of ', $num_lines, ' lines.', "<br />";
	    echo 'Longest line found on line ', $longest_on, ' with ', strlen($longest), ' characters.', "<br />";
	}

?>
